package jdwang.hadoop;
import java.io.IOException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;

import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Reducer;

//public class TDCS_MRP_Reducer extends Reducer<Text, Text, Text, Text> {
//public class TDCS_MRP_TimeInterval_Reducer_3 extends Reducer<Text, IntWritable, Text, IntWritable> {
public class TDCS_MRP_TimeInterval_Reducer_4_Filter_Weekday_StartEndGantyrID extends Reducer<Text, Text, Text, Text> {
    
	//private IntWritable result = new IntWritable();
	public void reduce(Text key, Iterable <Text> values, Context context) throws IOException, InterruptedException {
	//public void reduce(Text key, Iterable<IntWritable> values, Context context) throws IOException, InterruptedException {	
	// process values	
		
		//01F0005S_00_M1_30 01F0017S_00_M1_31 01F0029S_00_M1_32 01F0061S_00_M1_34 01F0099S_00_M1_36 03F0116S_00_M1_39 03F0136S_00_M1_40 03F0158S_00_M1_41 05F0000S_00_M1_42##2##2##9##(2016-11-29_Mon_31#1#1)(2016-12-17_Fri_31#1#1)
		//01F0005S_00_M1_53 01F0017S_00_M1_54 01F0029S_00_M1_55 01F0061S_00_M1_57 01F0099S_01_M1_00 03F0116S_01_M1_02 03F0136S_01_M1_03 03F0158S_01_M1_05 05F0000S_01_M1_05 05F0055S_01_M1_09 05F0287S_01_M1_26##2##2##11##(2017-02-07_Mon_31#1#1)(2017-02-11_Fri_31#1#1)
		//01F0005S_01_M1_50 01F0017S_01_M1_51 01F0029S_01_M1_52 01F0061S_01_M1_54 01F0099S_01_M1_57 03F0116S_01_M1_59 03F0136S_02_M1_00 03F0158S_02_M1_02 05F0000S_02_M1_03 05F0055S_02_M1_07##3##3##10##(2016-12-25_Sat_31#1#1)(2017-01-27_Thu_31#1#1)(2017-01-31_Mon_31#1#1)

		///* Wed 01F0005S 01
		//String Class_QantryID_Pattern = oneWeekday + "_"+QantryID_Pattern;
	     
		String keyStr = key.toString();
		
		String [] InfoItems = keyStr.split(" ");
		
		String OneWeekday = InfoItems[0];
		String FirstQantryID = InfoItems[1];
		String Hour = InfoItems[2];
		
		String Weekday_Hour = OneWeekday+" "+ Hour;
		
		TreeMap TimeIntervalDistribution = new TreeMap<Integer, Integer>();
		TreeMap TimeIntervalDistribution1 = new TreeMap<Integer, Integer>();
		
		TreeMap TotalTime_WeekdayDistribution = new TreeMap<String, Integer>();
				
		String Temp = "";
		int SumMin = 0;
		int SumTF = 0;
		int Max = 0;
		int Min = 1000000000;
		
		for (Text val : values) {
			//context.write(key, val);
			
			Temp = val.toString();
			//String CompositeValue = "Total_Min="+Integer.toString(TotalTime)+"##"+TF+"##"+WeekdayDistribution;
	    	
			String [] Items = Temp.split("##");
						
			Integer TotalTime = Integer.valueOf(Items[0].substring(10)); // the remainder substring after "Total_Min="
			if (TotalTime > Max) {
				Max = TotalTime;
			}
			if (TotalTime < Min) {
				Min = TotalTime;
			}
			
			Integer TF = Integer.valueOf(Items[1]);
			
			SumMin = SumMin + TotalTime*TF;
			SumTF = SumTF + TF;
			
			if (TimeIntervalDistribution.containsKey(TotalTime)) {
				Integer temp = (int) TimeIntervalDistribution.get(TotalTime) + TF;
				TimeIntervalDistribution.put(TotalTime, temp);
			} else {
				TimeIntervalDistribution.put(TotalTime, TF);
			}
		} // End of for (Text val : values)
		//for (int i=Min; i<=Max;++i) {
		for (int i=30; i<=60;++i) {
			TimeIntervalDistribution1.put(i, 0);
		}	
		//for (Integer i=Min; i<=Max;++i) {	
		for (int i=30; i<=60;++i) {
			if (TimeIntervalDistribution.containsKey(i)) {
				Integer temp = (Integer) TimeIntervalDistribution.get(i);
				TimeIntervalDistribution1.put(i,temp);
			}
		} // End of for (int i=Min; i<=Max;++i) 
		
			
		float AvgMin = SumMin/SumTF; 
		
		Set <Integer> Keys = TimeIntervalDistribution1.keySet();	
		String TotalTimeDistribution = "";
		for ( Iterator i1 = Keys.iterator(); i1.hasNext();) {
		     Integer onekey = (Integer) i1.next();
		     Integer value =  (Integer) TimeIntervalDistribution1.get(onekey);
		     //System.out.println(key + " = " + value);
		     //TotalTimeDistribution = TotalTimeDistribution+"(" + Integer.toString(onekey)+":"+Integer.toString(value)+")";
		     TotalTimeDistribution = TotalTimeDistribution + ","+ Integer.toString(value);
				
		} // End of for ( Iterator i = Keys.iterator(); i.hasNext();)
		
		
		
		Text ValueKey = new Text();
		Text QantryID_Hour = new Text();
		String Result = Integer.toString(SumTF)+"#"
						+Integer.toString(Max)+"#"
						+Integer.toString(Min)+"#"
						+String.valueOf(AvgMin)+"#"
						+TotalTimeDistribution;
				
		QantryID_Hour.set(Weekday_Hour);
		ValueKey.set(Result);
		
		context.write(QantryID_Hour, ValueKey);
		//*/
		/*
		int sum = 0;
		for (IntWritable val : values) {
			sum += val.get();
		}
		result.set(sum);
		context.write(key, result);
		*/
	} //End of public void reduce
} // End of public class TDCS_MRP_Reducer extends Reducer
